Index: /branches/2014/dev_r4650_UKMO14.12_STAND_ALONE_OBSOPER/NEMOGCM/TOOLS/SIREN/src/boundary.f90
===================================================================
--- /branches/2014/dev_r4650_UKMO14.12_STAND_ALONE_OBSOPER/NEMOGCM/TOOLS/SIREN/src/boundary.f90	(revision 5599)
+++ /branches/2014/dev_r4650_UKMO14.12_STAND_ALONE_OBSOPER/NEMOGCM/TOOLS/SIREN/src/boundary.f90	(revision 5600)
@@ -8,17 +8,105 @@
 !> @brief
 !> This module manage boundary.
-!
+!>
 !> @details
+!>    define type TBDY:<br/>
+!> @code
+!>    TYPE(TBDY) :: tl_bdy<br/>
+!> @endcode
 !>
+!>    to initialise boundary structure:<br/>
+!> @code
+!>    tl_bdy=boundary_init(td_var, [ld_north,] [ld_south,] [ld_east,] [ld_west,]
+!>    [cd_north,] [cd_south,] [cd_east,] [cd_west,] [ld_oneseg])
+!> @endcode
+!>       - td_var is variable structure
+!>       - ld_north is logical to force used of north boundary [optional]
+!>       - ld_south is logical to force used of north boundary [optional]
+!>       - ld_east  is logical to force used of north boundary [optional]
+!>       - ld_west  is logical to force used of north boundary [optional]
+!>       - cd_north is string character description of north boundary [optional]
+!>       - cd_south is string character description of north boundary [optional]
+!>       - cd_east  is string character description of north boundary [optional]
+!>       - cd_west  is string character description of north boundary [optional]
+!>       - ld_oneseg is logical to force to use only one segment for each boundary [optional]
 !>
+!>    to get boundary cardinal:<br/>
+!>    - tl_bdy\%c_card
 !>
+!>    to know if boundary is use:<br/>
+!>    - tl_bdy\%l_use
 !>
+!>    to get the number of segment in boundary:<br/>
+!>    - tl_bdy\%i_nseg
 !>
-!> @author
-!> J.Paul
+!>    to get array of segment in boundary:<br/>
+!>    - tl_bdy\%t_seg(:)
+!>
+!>    to get orthogonal segment index of north boundary:<br/>
+!>    - tl_bdy\%t_seg(jp_north)%\i_index
+!>
+!>    to get segment width of south boundary:<br/>
+!>    - tl_bdy\%t_seg(jp_south)%\i_width
+!>
+!>    to get segment first indice of east boundary:<br/>
+!>    - tl_bdy\%t_seg(jp_east)%\i_first
+!>
+!>    to get segment last indice of west boundary:<br/>
+!>    - tl_bdy\%t_seg(jp_west)%\i_last
+!>
+!>    to print information about boundary:<br/>
+!> @code
+!>    CALL boundary_print(td_bdy)
+!> @endcode
+!>       - td_bdy is boundary structure or a array of boundary structure
+!>
+!>    to clean boundary structure:<br/>
+!> @code
+!>    CALL boundary_clean(td_bdy)
+!> @endcode
+!>
+!>    to get indices of each semgent for each boundary:<br/>
+!> @code
+!>    CALL boundary_get_indices( td_bdy, td_var, ld_oneseg)
+!> @endcode
+!>       - td_bdy is boundary structure
+!>       - td_var is variable structure
+!>       - ld_oneseg is logical to force to use only one segment for each boundary [optional]
+!>
+!>    to check boundary indices and corner:<br/>
+!> @code
+!>    CALL boundary_check(td_bdy, td_var)
+!> @endcode
+!>       - td_bdy is boundary structure
+!>       - td_var is variable structure
+!>
+!>    to check boundary corner:<br/>
+!> @code
+!>    CALL boundary_check_corner(td_bdy, td_var)
+!> @endcode
+!>       - td_bdy is boundary structure
+!>       - td_var is variable structure
+!>
+!>    to create filename with cardinal name inside:<br/>
+!> @code
+!>    cl_filename=boundary_set_filename(cd_file, cd_card)
+!> @endcode
+!>       - cd_file = original file name
+!>       - cd_card = cardinal name
+!>
+!>    to swap array for east and north boundary:<br/>
+!> @code
+!>    CALL boundary_swap( td_var, td_bdy )
+!> @endcode
+!>       - td_var is variable strucutre
+!>       - td_bdy is boundary strucutre
+!>
+!> @author J.Paul
 ! REVISION HISTORY:
-!> @date Nov, 2013 - Initial Version
-!> @todo
-!> - add description generique de l'objet boundary
+!> @date November, 2013 - Initial Version
+!> @date September, 2014 - add boundary description
+!> @date November, 2014 - Fix memory leaks bug
+!> 
+!> @todo add schematic to boundary structure description
 !> 
 !> @note Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
@@ -29,31 +117,19 @@
    USE phycst                          ! physical constant
    USE kind                            ! F90 kind parameter
-   USE logger                             ! log file manager
+   USE logger                          ! log file manager
    USE fct                             ! basic useful function
-!   USE date                            ! date manager
-!   USE att                             ! attribute manager
-!   USE dim                             ! dimension manager
    USE var                             ! variable manager
-!   USE file                            ! file manager
-!   USE iom                             ! I/O manager
-!   USE dom                             ! domain  manager
-!   USE grid                            ! grid manager
-!   USE extrap                          ! extrapolation manager
-!   USE interp                          ! interpolation manager
-!   USE filter                          ! filter manager
-!   USE mpp                             ! MPP manager
-!   USE iom_mpp                         ! MPP I/O manager
 
    IMPLICIT NONE
-   PRIVATE
    ! NOTE_avoid_public_variables_if_possible
 
    ! type and variable
-   PUBLIC :: ip_ncard !< number of cardinal point
-   PUBLIC :: ip_card  !< table of cardinal point
    PUBLIC :: TBDY     !< boundary structure
    PUBLIC :: TSEG     !< segment structure
 
+   PRIVATE :: im_width !< boundary width
+
    ! function and subroutine
+   PUBLIC :: boundary_copy         !< copy boundary structure
    PUBLIC :: boundary_init         !< initialise boundary structure
    PUBLIC :: boundary_print        !< print information about boundary
@@ -63,26 +139,29 @@
    PUBLIC :: boundary_check_corner !< check boundary corner
    PUBLIC :: boundary_set_filename !< set boundary filename
-   PUBLIC :: boundary_clean_interp !< clean interpolated boundary
    PUBLIC :: boundary_swap         !< swap array for north and east boundary
 
-   PRIVATE :: boundary__init_wrapper    !< initialise a boundary structure
-   PRIVATE :: boundary__init            !< initialise basically a boundary structure
-!   PRIVATE :: boundary__copy            !< copy boundary structure in another
-   PRIVATE :: boundary__copy_unit       !< copy boundary structure in another
-   PRIVATE :: boundary__copy_tab        !< copy boundary structure in another
-   PRIVATE :: boundary__add_seg         !< add one segment structure to a boundary 
-   PRIVATE :: boundary__del_seg         !< remove all segments of a boundary
-   PRIVATE :: boundary__get_info        !< get boundary information from boundary description string character.
-   PRIVATE :: boundary__get_seg_number  !< compute the number of sea segment for one boundary
-   PRIVATE :: boundary__get_seg_indices !< get segment indices for one boundary 
-   PRIVATE :: boundary__print_unit      !< print information about one boundary
-   PRIVATE :: boundary__print_tab       !< print information about a table of boundary
+   PRIVATE :: boundary__clean_unit      ! clean boundary structure 
+   PRIVATE :: boundary__clean_arr       ! clean array of boundary structure 
+   PRIVATE :: boundary__init_wrapper    ! initialise a boundary structure
+   PRIVATE :: boundary__init            ! initialise basically a boundary structure
+   PRIVATE :: boundary__copy_unit       ! copy boundary structure in another
+   PRIVATE :: boundary__copy_arr        ! copy boundary structure in another
+   PRIVATE :: boundary__add_seg         ! add one segment structure to a boundary 
+   PRIVATE :: boundary__del_seg         ! remove all segments of a boundary
+   PRIVATE :: boundary__get_info        ! get boundary information from boundary description string character.
+   PRIVATE :: boundary__get_seg_number  ! compute the number of sea segment for one boundary
+   PRIVATE :: boundary__get_seg_indices ! get segment indices for one boundary 
+   PRIVATE :: boundary__print_unit      ! print information about one boundary
+   PRIVATE :: boundary__print_arr       ! print information about a array of boundary
    
-   PRIVATE :: seg__init    !< initialise segment structure
-   PRIVATE :: seg__clean   !< clean segment structure
-   PRIVATE :: seg__copy    !< copy segment structure in another
-
-   !> @struct
-   TYPE TSEG   
+   PRIVATE :: seg__init       ! initialise segment structure
+   PRIVATE :: seg__clean      ! clean segment structure
+   PRIVATE :: seg__clean_unit ! clean segment structure
+   PRIVATE :: seg__clean_arr  ! clean array of segment structure
+   PRIVATE :: seg__copy       ! copy segment structure in another
+   PRIVATE :: seg__copy_unit  ! copy segment structure in another
+   PRIVATE :: seg__copy_arr   ! copy array of segment structure in another
+
+   TYPE TSEG   !< segment structure
       INTEGER(i4) :: i_index = 0 !< segment index
       INTEGER(i4) :: i_width = 0 !< segment width
@@ -91,23 +170,10 @@
    END TYPE TSEG
 
-   !> @struct
-   TYPE TBDY
-      CHARACTER(LEN=lc) :: c_card = ''
-      LOGICAL           :: l_use  = .FALSE.
-      INTEGER(i4)       :: i_nseg = 0
-      TYPE(TSEG), DIMENSION(:), POINTER :: t_seg => NULL()
+   TYPE TBDY !< boundary structure
+      CHARACTER(LEN=lc) :: c_card = ''          !< boundary cardinal
+      LOGICAL           :: l_use  = .FALSE.     !< boundary use or not 
+      INTEGER(i4)       :: i_nseg = 0           !< number of segment in boundary
+      TYPE(TSEG), DIMENSION(:), POINTER :: t_seg => NULL() !<  array of segment structure
    END TYPE TBDY
-
-   INTEGER(i4), PARAMETER :: ip_ncard=4
-   CHARACTER(LEN=lc), DIMENSION(ip_ncard), PARAMETER :: ip_card = &
-   &  (/ 'north', &
-   &     'south', &
-   &     'east ', &
-   &     'west ' /)
-
-   INTEGER(i4), PARAMETER :: jp_north=1
-   INTEGER(i4), PARAMETER :: jp_south=2
-   INTEGER(i4), PARAMETER :: jp_east =3
-   INTEGER(i4), PARAMETER :: jp_west =4
 
    INTEGER(i4), PARAMETER :: im_width=10
@@ -119,11 +185,25 @@
    INTERFACE boundary_print
       MODULE PROCEDURE boundary__print_unit 
-      MODULE PROCEDURE boundary__print_tab 
+      MODULE PROCEDURE boundary__print_arr 
    END INTERFACE boundary_print
 
-   INTERFACE ASSIGNMENT(=)
+   INTERFACE boundary_clean
+      MODULE PROCEDURE boundary__clean_unit   
+      MODULE PROCEDURE boundary__clean_arr    
+   END INTERFACE
+
+   INTERFACE seg__clean
+      MODULE PROCEDURE seg__clean_unit   
+      MODULE PROCEDURE seg__clean_arr    
+   END INTERFACE
+
+   INTERFACE boundary_copy
       MODULE PROCEDURE boundary__copy_unit 
-      MODULE PROCEDURE boundary__copy_tab 
-      MODULE PROCEDURE seg__copy   ! copy segment structure
+      MODULE PROCEDURE boundary__copy_arr 
+   END INTERFACE   
+
+   INTERFACE seg__copy
+      MODULE PROCEDURE seg__copy_unit   ! copy segment structure
+      MODULE PROCEDURE seg__copy_arr    ! copy array of segment structure
    END INTERFACE   
 
@@ -131,23 +211,28 @@
    !-------------------------------------------------------------------
    !> @brief
-   !> This subroutine copy boundary structure in another boundary
-   !> structure
+   !> This subroutine copy a array of boundary structure in another one
    !> @details 
    !>
+   !> @warning do not use on the output of a function who create or read an
+   !> attribute (ex: tl_bdy=boundary_copy(boundary_init()) is forbidden).
+   !> This will create memory leaks.
    !> @warning to avoid infinite loop, do not use any function inside 
    !> this subroutine
    !>
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
+   !> @date November, 2013 - Initial Version
+   !> @date November, 2014
+   !>    - use function instead of overload assignment operator 
+   !> (to avoid memory leak)
    !
-   !> @param[out] td_bdy1  : boundary structure
-   !> @param[in] td_bdy2  : boundary structure
+   !> @param[in] td_bdy   array of boundary structure
+   !> @return copy of input array of boundary structure 
    !-------------------------------------------------------------------
-   !> @code
-   SUBROUTINE boundary__copy_tab( td_bdy1, td_bdy2 )
+   FUNCTION boundary__copy_arr( td_bdy )
       IMPLICIT NONE
       ! Argument
-      TYPE(TBDY), DIMENSION(:), INTENT(OUT) :: td_bdy1
-      TYPE(TBDY), DIMENSION(:), INTENT(IN)  :: td_bdy2
+      TYPE(TBDY), DIMENSION(:), INTENT(IN)  :: td_bdy
+      ! function
+      TYPE(TBDY), DIMENSION(SIZE(td_bdy(:))) :: boundary__copy_arr
 
       ! local variable
@@ -156,34 +241,35 @@
       !----------------------------------------------------------------
 
-      IF( SIZE(td_bdy1(:)) /= SIZE(td_bdy2(:)) )THEN
-         CALL logger_error("BOUNDARY COPY: dimension of table of boundary differ")
-      ELSE
-         DO jk=1,SIZE(td_bdy1(:))
-            td_bdy1(jk)=td_bdy2(jk)
-         ENDDO
-      ENDIF
-   END SUBROUTINE boundary__copy_tab
-   !> @endcode
+      DO jk=1,SIZE(td_bdy(:))
+         boundary__copy_arr(jk)=boundary_copy(td_bdy(jk))
+      ENDDO
+
+   END FUNCTION boundary__copy_arr
    !-------------------------------------------------------------------
    !> @brief
-   !> This subroutine copy boundary structure in another boundary
-   !> structure
+   !> This subroutine copy boundary structure in another one
    !> @details 
    !>
+   !> @warning do not use on the output of a function who create or read an
+   !> attribute (ex: tl_bdy=boundary_copy(boundary_init()) is forbidden).
+   !> This will create memory leaks.
    !> @warning to avoid infinite loop, do not use any function inside 
    !> this subroutine
    !>
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
+   !> @date November, 2013 - Initial Version
+   !> @date November, 2014
+   !>    - use function instead of overload assignment operator 
+   !> (to avoid memory leak)
    !
-   !> @param[out] td_bdy1  : boundary structure
-   !> @param[in] td_bdy2  : boundary structure
+   !> @param[in] td_bdy   boundary structure
+   !> @return copy of input boundary structure
    !-------------------------------------------------------------------
-   !> @code
-   SUBROUTINE boundary__copy_unit( td_bdy1, td_bdy2 )
+   FUNCTION boundary__copy_unit( td_bdy )
       IMPLICIT NONE
       ! Argument
-      TYPE(TBDY), INTENT(OUT) :: td_bdy1
-      TYPE(TBDY), INTENT(IN)  :: td_bdy2
+      TYPE(TBDY), INTENT(IN)  :: td_bdy
+      ! function
+      TYPE(TBDY) :: boundary__copy_unit
 
       ! local variable
@@ -193,29 +279,30 @@
 
       ! copy variable name, id, ..
-      td_bdy1%c_card     = TRIM(td_bdy2%c_card)
-      td_bdy1%i_nseg     = td_bdy2%i_nseg
-      td_bdy1%l_use      = td_bdy2%l_use
+      boundary__copy_unit%c_card     = TRIM(td_bdy%c_card)
+      boundary__copy_unit%i_nseg     = td_bdy%i_nseg
+      boundary__copy_unit%l_use      = td_bdy%l_use
 
       ! copy segment
-      IF( ASSOCIATED(td_bdy1%t_seg) ) DEALLOCATE(td_bdy1%t_seg)
-      IF( ASSOCIATED(td_bdy2%t_seg) .AND. td_bdy1%i_nseg > 0 )THEN
-         ALLOCATE( td_bdy1%t_seg(td_bdy1%i_nseg) )
-         DO ji=1,td_bdy1%i_nseg
-            td_bdy1%t_seg(ji)=td_bdy2%t_seg(ji)
+      IF( ASSOCIATED(boundary__copy_unit%t_seg) )THEN
+         CALL seg__clean(boundary__copy_unit%t_seg(:))
+         DEALLOCATE(boundary__copy_unit%t_seg)
+      ENDIF
+      IF( ASSOCIATED(td_bdy%t_seg) .AND. boundary__copy_unit%i_nseg > 0 )THEN
+         ALLOCATE( boundary__copy_unit%t_seg(boundary__copy_unit%i_nseg) )
+         DO ji=1,boundary__copy_unit%i_nseg
+            boundary__copy_unit%t_seg(ji)=td_bdy%t_seg(ji)
          ENDDO
       ENDIF
 
-   END SUBROUTINE boundary__copy_unit
-   !> @endcode
+   END FUNCTION boundary__copy_unit
    !-------------------------------------------------------------------
    !> @brief This subroutine clean boundary structure
    !
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
+   !> @date November, 2013 - Initial Version
    !
-   !> @param[inout] td_bdy : boundary strucutre
+   !> @param[inout] td_bdy boundary strucutre
    !-------------------------------------------------------------------
-   !> @code
-   SUBROUTINE boundary_clean( td_bdy )
+   SUBROUTINE boundary__clean_unit( td_bdy )
       IMPLICIT NONE
       ! Argument
@@ -226,42 +313,64 @@
 
       ! loop indices
+      !----------------------------------------------------------------
+
+      CALL logger_info( &
+      &  " CLEAN: reset boundary "//TRIM(td_bdy%c_card) )
+
+      ! del segment
+      IF( ASSOCIATED(td_bdy%t_seg) )THEN
+         ! clean each segment
+         CALL seg__clean(td_bdy%t_seg(:) )
+         DEALLOCATE( td_bdy%t_seg )
+      ENDIF
+
+      ! replace by empty structure
+      td_bdy=boundary_copy(tl_bdy)
+
+   END SUBROUTINE boundary__clean_unit
+   !-------------------------------------------------------------------
+   !> @brief This subroutine clean array of boundary structure
+   !
+   !> @author J.Paul
+   !> @date September, 2014 - Initial Version
+   !
+   !> @param[inout] td_bdy boundary strucutre
+   !-------------------------------------------------------------------
+   SUBROUTINE boundary__clean_arr( td_bdy )
+      IMPLICIT NONE
+      ! Argument
+      TYPE(TBDY), DIMENSION(:), INTENT(INOUT) :: td_bdy
+
+      ! local variable
+      ! loop indices
       INTEGER(i4) :: ji
       !----------------------------------------------------------------
 
-      CALL logger_info( &
-      &  " CLEAN: reset boundary "//TRIM(td_bdy%c_card) )
-
-      ! del segment
-      IF( ASSOCIATED(td_bdy%t_seg) )THEN
-         ! clean each attribute
-         DO ji=td_bdy%i_nseg,1,-1
-            CALL seg__clean(td_bdy%t_seg(ji) )
-         ENDDO
-         DEALLOCATE( td_bdy%t_seg )
-      ENDIF
-
-      ! replace by empty structure
-      td_bdy=tl_bdy
-
-   END SUBROUTINE boundary_clean
-   !> @endcode
-   !------------------------------------------------------------------- 
-   !> @brief This function put cardinal name inside file name  
+      DO ji=SIZE(td_bdy(:)),1,-1
+         CALL boundary_clean( td_bdy(ji) )
+      ENDDO
+
+   END SUBROUTINE boundary__clean_arr
+   !------------------------------------------------------------------- 
+   !> @brief This function put cardinal name inside file name.
    ! 
    !> @details 
    ! 
    !> @author J.Paul 
-   !> - Nov, 2013- Initial Version 
-   ! 
-   !> @param[in] cd_file : file name 
-   !> @param[in] cd_card : cardinal name 
+   !> @date November, 2013 - Initial Version 
+   ! 
+   !> @param[in] cd_file   file name 
+   !> @param[in] cd_card   cardinal name 
+   !> @param[in] id_seg    segment number 
+   !> @param[in] cd_date   file date (format: y????m??d??) 
    !> @return file name with cardinal name inside
    !------------------------------------------------------------------- 
-   !> @code 
-   FUNCTION boundary_set_filename(cd_file, cd_card) 
+   FUNCTION boundary_set_filename(cd_file, cd_card, id_seg, cd_date) 
       IMPLICIT NONE 
       ! Argument
       CHARACTER(LEN=*), INTENT(IN) :: cd_file
       CHARACTER(LEN=*), INTENT(IN) :: cd_card
+      INTEGER(i4)     , INTENT(IN), OPTIONAL :: id_seg
+      CHARACTER(LEN=*), INTENT(IN), OPTIONAL :: cd_date
 
       ! function 
@@ -273,4 +382,6 @@
       CHARACTER(LEN=lc) :: cl_base
       CHARACTER(LEN=lc) :: cl_suffix
+      CHARACTER(LEN=lc) :: cl_segnum
+      CHARACTER(LEN=lc) :: cl_date
       CHARACTER(LEN=lc) :: cl_name
       ! loop indices 
@@ -288,6 +399,19 @@
          cl_base  =fct_split(TRIM(cl_basename),1,'.')
          cl_suffix=fct_split(TRIM(cl_basename),2,'.')
-
-         cl_name=TRIM(cl_base)//"_"//TRIM(cd_card)//"."//TRIM(cl_suffix)
+         
+         IF( PRESENT(id_seg) )THEN
+            cl_segnum="_"//TRIM(fct_str(id_seg))//"_"
+         ELSE
+            cl_segnum=""
+         ENDIF
+
+         IF( PRESENT(cd_date) )THEN
+            cl_date=TRIM(ADJUSTL(cd_date))
+         ELSE
+            cl_date=""
+         ENDIF
+
+         cl_name=TRIM(cl_base)//"_"//TRIM(cd_card)//TRIM(cl_segnum)//&
+         &        TRIM(cl_date)//"."//TRIM(cl_suffix)
 
          boundary_set_filename=TRIM(cl_dirname)//"/"//TRIM(cl_name)
@@ -298,7 +422,6 @@
  
    END FUNCTION boundary_set_filename 
-   !> @endcode
-   !------------------------------------------------------------------- 
-   !> @brief This function initialise a boundary structure 
+   !------------------------------------------------------------------- 
+   !> @brief This function initialise a boundary structure.
    ! 
    !> @details 
@@ -318,21 +441,26 @@
    !> specify it for each segment.
    !> ex : cn_north='index1,first1,last1(width)|index2,first2,last2'
-   ! 
+   !>
+   !> @note boundaries are compute on T point. change will be done to get data
+   !> on other point when need be. 
+   !>
    !> @author J.Paul 
-   !> - Nov, 2013- Initial Version 
-   ! 
-   !> @param[in] td_var : variable structure 
-   !> @param[in] ld_north : use north boundary or not 
-   !> @param[in] ld_south : use south boundary or not 
-   !> @param[in] ld_east  : use east  boundary or not 
-   !> @param[in] ld_west  : use west  boundary or not 
-   !> @param[in] cd_north : north boundary description 
-   !> @param[in] cd_south : south boundary description 
-   !> @param[in] cd_east  : east  boundary description 
-   !> @param[in] cd_west  : west  boundary description 
+   !> @date November, 2013 - Initial Version 
+   !> @date September, 2014
+   !> - add boolean to use only one segment for each boundary
+   !> - check boundary width
+   ! 
+   !> @param[in] td_var    variable structure 
+   !> @param[in] ld_north  use north boundary or not 
+   !> @param[in] ld_south  use south boundary or not 
+   !> @param[in] ld_east   use east  boundary or not 
+   !> @param[in] ld_west   use west  boundary or not 
+   !> @param[in] cd_north  north boundary description 
+   !> @param[in] cd_south  south boundary description 
+   !> @param[in] cd_east   east  boundary description 
+   !> @param[in] cd_west   west  boundary description 
+   !> @param[in] ld_oneseg force to use only one segment for each boundary 
    !> @return boundary structure
-   !> @todo use bondary_get_indices !!!!
-   !------------------------------------------------------------------- 
-   !> @code 
+   !------------------------------------------------------------------- 
    FUNCTION boundary__init_wrapper(td_var, &
    &                               ld_north, ld_south, ld_east, ld_west, &
@@ -356,4 +484,6 @@
 
       ! local variable 
+      INTEGER(i4)                            :: il_width
+      INTEGER(i4)      , DIMENSION(ip_ncard) :: il_max_width
       INTEGER(i4)      , DIMENSION(ip_ncard) :: il_index
       INTEGER(i4)      , DIMENSION(ip_ncard) :: il_min
@@ -390,16 +520,20 @@
          tl_bdy(jp_west )=boundary__init('west ',ld_west )
 
-         ! if EW cyclic no east west boundary
+         ! if EW cyclic no east west boundary and force to use one segment
          IF( td_var%i_ew >= 0 )THEN
-            CALL logger_debug("BOUNDARY INIT: cyclic no East West boundary")
+            CALL logger_info("BOUNDARY INIT: cyclic domain, "//&
+            &  "no East West boundary")
             tl_bdy(jp_east )%l_use=.FALSE.
             tl_bdy(jp_west )%l_use=.FALSE.
+
+            CALL logger_info("BOUNDARY INIT: force to use one segment due"//&
+            &  " to EW cyclic domain")
+            ll_oneseg=.TRUE.
          ENDIF
 
-         ! attention cas U /= T ???
-         il_index(jp_north)=td_var%t_dim(2)%i_len-ig_ghost
-         il_index(jp_south)=1+ig_ghost
-         il_index(jp_east )=td_var%t_dim(1)%i_len-ig_ghost
-         il_index(jp_west )=1+ig_ghost
+         il_index(jp_north)=td_var%t_dim(2)%i_len-ip_ghost
+         il_index(jp_south)=1+ip_ghost
+         il_index(jp_east )=td_var%t_dim(1)%i_len-ip_ghost
+         il_index(jp_west )=1+ip_ghost
 
          il_min(jp_north)=1
@@ -419,8 +553,28 @@
          IF( PRESENT(cd_west ) ) cl_card(jp_west )=TRIM(cd_west )
 
+         il_max_width(jp_north)=INT(0.5*(td_var%t_dim(2)%i_len-2*ip_ghost))
+         il_max_width(jp_south)=INT(0.5*(td_var%t_dim(2)%i_len-2*ip_ghost))
+         il_max_width(jp_east )=INT(0.5*(td_var%t_dim(1)%i_len-2*ip_ghost))
+         il_max_width(jp_west )=INT(0.5*(td_var%t_dim(1)%i_len-2*ip_ghost))
+
          DO jk=1,ip_ncard
 
+            ! check boundary width
+            IF( il_max_width(jk) <= im_width )THEN
+               IF( il_max_width(jk) <= 0 )THEN
+                  CALL logger_fatal("BOUNDARY INIT: domain too small to define"//&
+                  &                " boundaries.")
+               ELSE
+                  CALL logger_warn("BOUNDARY INIT: default boundary width too "//&
+                  &                "large for boundaries. force to use boundary"//&
+                  &                " on one point")
+                  il_width=1
+               ENDIF
+            ELSE
+               il_width=im_width
+            ENDIF
+
             ! define default segment
-            tl_seg=seg__init(il_index(jk),im_width,il_min(jk),il_max(jk))
+            tl_seg=seg__init(il_index(jk),il_width,il_min(jk),il_max(jk))
 
             IF( tl_bdy(jk)%l_use )THEN
@@ -453,4 +607,6 @@
 
             ENDIF
+            ! clean
+            CALL seg__clean(tl_seg)
 
          ENDDO
@@ -460,5 +616,5 @@
          CALL boundary_check(tl_bdy, td_var)
 
-         boundary__init_wrapper(:)=tl_bdy(:)
+         boundary__init_wrapper(:)=boundary_copy(tl_bdy(:))
 
          ! clean
@@ -470,5 +626,4 @@
  
    END FUNCTION boundary__init_wrapper 
-   !> @endcode 
    !------------------------------------------------------------------- 
    !> @brief This function initialise basically a boundary structure with
@@ -480,12 +635,11 @@
    ! 
    !> @author J.Paul 
-   !> - Nov, 2013- Initial Version 
-   ! 
-   !> @param[in]  cd_card : cardinal name
-   !> @param[in]  ld_use  : boundary use or not
-   !> @param[in]  td_seg  : segment structure
+   !> @date November, 2013 - Initial Version 
+   ! 
+   !> @param[in]  cd_card  cardinal name
+   !> @param[in]  ld_use   boundary use or not
+   !> @param[in]  td_seg   segment structure
    !> @return boundary structure
    !------------------------------------------------------------------- 
-   !> @code 
    FUNCTION boundary__init( cd_card, ld_use, td_seg ) 
       IMPLICIT NONE 
@@ -520,5 +674,4 @@
 
    END FUNCTION boundary__init
-   !> @endcode
    !------------------------------------------------------------------- 
    !> @brief This subroutine add one segment structure to a boundary structure 
@@ -527,10 +680,9 @@
    ! 
    !> @author J.Paul 
-   !> - Nov, 2013- Initial Version 
-   ! 
-   !> @param[inout] td_bdy : boundary structure  
-   !> @param[in] td_seg : segment structure  
-   !------------------------------------------------------------------- 
-   !> @code 
+   !> @date November, 2013 - Initial Version 
+   ! 
+   !> @param[inout] td_bdy boundary structure  
+   !> @param[in] td_seg    segment structure  
+   !------------------------------------------------------------------- 
    SUBROUTINE boundary__add_seg(td_bdy, td_seg) 
       IMPLICIT NONE 
@@ -554,6 +706,7 @@
          ELSE
             ! save temporary segment
-            tl_seg(:)=td_bdy%t_seg(:)
-
+            tl_seg(:)=seg__copy(td_bdy%t_seg(:))
+
+            CALL seg__clean(td_bdy%t_seg(:))
             DEALLOCATE( td_bdy%t_seg )
             ALLOCATE( td_bdy%t_seg(td_bdy%i_nseg+1), stat=il_status )
@@ -564,6 +717,8 @@
 
             ! copy segment in boundary before
-            td_bdy%t_seg(1:td_bdy%i_nseg)=tl_seg(:)
-
+            td_bdy%t_seg(1:td_bdy%i_nseg)=seg__copy(tl_seg(:))
+
+            ! clean
+            CALL seg__clean(tl_seg(:))
             DEALLOCATE(tl_seg)            
             
@@ -572,4 +727,5 @@
          ! no segment in boundary structure
          IF( ASSOCIATED(td_bdy%t_seg) )THEN
+            CALL seg__clean(td_bdy%t_seg(:))
             DEALLOCATE(td_bdy%t_seg)
          ENDIF
@@ -585,8 +741,7 @@
 
       ! add new segment
-      td_bdy%t_seg(td_bdy%i_nseg)=td_seg
+      td_bdy%t_seg(td_bdy%i_nseg)=seg__copy(td_seg)
 
    END SUBROUTINE boundary__add_seg 
-   !> @endcode
    !------------------------------------------------------------------- 
    !> @brief This subroutine remove all segments of a boundary structure 
@@ -595,9 +750,8 @@
    ! 
    !> @author J.Paul 
-   !> - Nov, 2013- Initial Version 
-   ! 
-   !> @param[inout]  td_bdy : boundary structure
-   !------------------------------------------------------------------- 
-   !> @code 
+   !> @date November, 2013 - Initial Version 
+   ! 
+   !> @param[inout]  td_bdy   boundary structure
+   !------------------------------------------------------------------- 
    SUBROUTINE boundary__del_seg(td_bdy) 
       IMPLICIT NONE 
@@ -610,4 +764,5 @@
 
       IF( ASSOCIATED(td_bdy%t_seg) )THEN
+         CALL seg__clean(td_bdy%t_seg(:))
          DEALLOCATE(td_bdy%t_seg)
       ENDIF
@@ -616,5 +771,4 @@
 
    END SUBROUTINE boundary__del_seg 
-   !> @endcode
    !------------------------------------------------------------------- 
    !> @brief This function get information about boundary from string character. 
@@ -627,10 +781,9 @@
    !> 
    !> @author J.Paul 
-   !> - Nov, 2013- Initial Version 
-   ! 
-   !> @param[in] cd_card : boundary description
+   !> @date November, 2013 - Initial Version 
+   ! 
+   !> @param[in] cd_card   boundary description
    !> @return boundary structure
    !------------------------------------------------------------------- 
-   !> @code 
    FUNCTION boundary__get_info(cd_card) 
       IMPLICIT NONE 
@@ -737,8 +890,10 @@
          ji=ji+1
          cl_seg=fct_split(cd_card,ji)
+
+         ! clean
+         CALL seg__clean(tl_seg)
       ENDDO 
 
    END FUNCTION boundary__get_info 
-   !> @endcode
    !------------------------------------------------------------------- 
    !> @brief This subroutine get indices of each semgent for each boundary.
@@ -757,11 +912,10 @@
    ! 
    !> @author J.Paul 
-   !> - Nov, 2013- Initial Version 
-   ! 
-   !> @param[inout] td_bdy : boundary structure  
-   !> @param[in] td_var : variable structure 
-   !> @param[in] ld_onseg : use only one sgment for each boundary 
-   !------------------------------------------------------------------- 
-   !> @code 
+   !> @date November, 2013 - Initial Version 
+   ! 
+   !> @param[inout] td_bdy boundary structure  
+   !> @param[in] td_var    variable structure 
+   !> @param[in] ld_onseg  use only one sgment for each boundary 
+   !------------------------------------------------------------------- 
    SUBROUTINE boundary_get_indices( td_bdy, td_var, ld_oneseg) 
       IMPLICIT NONE 
@@ -811,5 +965,5 @@
 
                IF( ll_oneseg .AND. td_bdy(jk)%l_use )THEN
-                  tl_seg=td_bdy(jk)%t_seg(1)
+                  tl_seg=seg__copy(td_bdy(jk)%t_seg(1))
                   ! use last indice of last segment
                   tl_seg%i_last=td_bdy(jk)%t_seg(td_bdy(jk)%i_nseg)%i_last
@@ -820,4 +974,7 @@
                   ! add one segment
                   CALL boundary__add_seg(td_bdy(jk),tl_seg)
+
+                  ! clean
+                  CALL seg__clean(tl_seg)
                ENDIF
 
@@ -829,5 +986,4 @@
 
    END SUBROUTINE boundary_get_indices 
-   !> @endcode
    !------------------------------------------------------------------- 
    !> @brief This subroutine compute the number of sea segment. 
